// Local headers
#include "StatisticsCalculator.h"

// STL headers
#include <algorithm>
#include <fstream>
#include <sstream>


bool StatisticsCalculator::ReadCSVfile(const std::string& filename, char column)
{
  Clear();
  std::ifstream input(filename.c_str());
  if (input.bad())
  { 
    std::cout << "File called " << filename << "is not found" << std::endl;
    return false;
  }
  std::string line;
  unsigned int nline=0;
  while(std::getline(input, line))
  {
    nline++;
    if (nline==1) continue;
    std::istringstream istr(line);
    unsigned int nword=0;
    std::string tmp;
    while(std::getline(istr, tmp, ';'))
    { 
      nword++;
      if (nword==column)
      {
        std::stringstream str2;
        str2 << tmp;
        double value;
        str2 >> value;
        AddValue(value);
        break;
      }
    }
  }
  return true;
}

bool StatisticsCalculator::AddValue(double value)
{
    if (data_.size()<nmax_) data_.push_back(value);
    else
    {
      std::cout << "StatisticsCalculator: the maximum number of events is reached."
                << " The event is skipped." << std::endl;
      return false;
    }
    ordered_=false;
    return true;
 }


double StatisticsCalculator::GetMediane()
  {
    if (data_.size()==0) return -999.;
    if (!ordered_)
    {
      for (unsigned int i=0;i<data_.size();i++)
	for (unsigned int j=i;j<data_.size();j++)
	  {
	    if (data_[j]<data_[i])
	      {
		double tmp=data_[i];
		data_[i]=data_[j];
		data_[j]=data_[i];
	      }
	  }
    }
    if ((data_.size()%2)==1) return data_[data_.size()/2];
    else return 0.5*(data_[data_.size()/2-1]+data_[data_.size()/2]);
  }


double StatisticsCalculator::GetMin()
  {
    if (data_.size()==0) return -999;
    double minvalue=0;
    for (unsigned int i=0;i<data_.size();i++)
    {
      if (i==0) minvalue=data_[i];
      if (minvalue>data_[i]) minvalue=data_[i];
    }
      
    return minvalue;
  }
  

double StatisticsCalculator::GetMax()
  {
    if (data_.size()==0) return -999;
    double maxvalue=0;
    for (unsigned int i=0;i<data_.size();i++)
    {
      if (i==0) maxvalue=data_[i];
      if (maxvalue<data_[i]) maxvalue=data_[i];
    }
      
    return maxvalue;
  }
